//-----------------------------------------------------------------------------
//
// PictBear Second Edition <Filter/Import/Export> Plugin Header File
//
// $Version 1.6 (last modified: 2004/05/08)
//
//                                Copyright(C) 1999-2004 by Yasuyuki Kashiwagi.
//                                                         All Rights Reserved.
//
//-----------------------------------------------------------------------------

#ifndef __PBPLUGIN_H
#define __PBPLUGIN_H

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif


///////////////////////////////////////////////////////////////////////////////
// PictBear Ŏgpff[^
//-----------------------------------------------------------------------------
// ׂĂ̒l 0 ` 255 ŕ\A0 ŒlA255 ől\킷B
// 255 ɋ߂ÂقǁẢeȂARGBA(255, 255, 255, 255) ŔƂȂB
//-----------------------------------------------------------------------------

#pragma pack(1)

typedef union tagPixel32 
{
	DWORD color; // J[l

	struct 
	{
		BYTE b;  // (Blue)
		BYTE g;  // (Green)
		BYTE r;  // (Red)
		BYTE a;  // sx(Opacity)
	} item;
} Pixel32;

#pragma pack()


///////////////////////////////////////////////////////////////////////////////
// vOCp萔
//-----------------------------------------------------------------------------
// evOC̃o[WEނ`BvOC PB_GetPluginInfo ŁA
// Œ`Ăo[WEޒ萔ԂKvB
//-----------------------------------------------------------------------------

//#define PBPLUGIN_VERSION		0		// o[W݊
										// @Vo[Wł͉L萔gp

#define PBPLUGIN_FILTER_VERSION	0x01	// tB^vOC̃o[W
#define PBPLUGIN_IMPORT_VERSION	0x00	// C|[gvOC̃o[W
#define PBPLUGIN_EXPORT_VERSION	0x00	// GNX|[gvOC̃o[W

#define PBPLUGIN_UNKNOWN		0x00	// sȃvOC
#define PBPLUGIN_FILTER			0x01	// tB^vOC
#define PBPLUGIN_IMPORT			0x02	// C|[gvOC
#define PBPLUGIN_EXPORT			0x03	// GNX|[gvOC


///////////////////////////////////////////////////////////////////////////////
// vOCpG[R[h
//-----------------------------------------------------------------------------
// vOC͎sʂ\킷G[R[hԂKvBs֐𔲂鎞
// ́Aɒ`ꂽ萔ԂƁB
// 
//  F: tB^vOCŎgp\
//  I: C|[gvOCŎgp\
//  E: GNX|[gvOCŎgp\
//-----------------------------------------------------------------------------

#define PB_ERR_SUCCESS				0	// G[(F/I/E)
#define PB_ERR_UNKNOWN				1	// sȃG[(F/I/E)
#define PB_ERR_FILE_NOT_FOUND		2	// t@C݂Ȃ(I)
#define PB_ERR_FILE_CANNOT_CREATE	3	// t@C쐬łȂ(E)
#define PB_ERR_BAD_FORMAT			4	// t@C̃tH[}bgُ(I)
#define PB_ERR_WRITE_ERROR			5	// ݃G[(E)
#define PB_ERR_UNKNOWN_EXTENSION	6	// sȊgq(I/E)
#define PB_ERR_CANCELED				7	// s(F/I/E)


///////////////////////////////////////////////////////////////////////////////
// tB^vOC̑ΉtH[}bg萔
//-----------------------------------------------------------------------------
// tB^vOC͑ΉĂC[W^Cv萔 PBF_GetSupportedFormat 
// ŕԂKvBPBF_REFERENCE_IMAGE ZbgƁAC[WŜ̃f[^
// tB^ɓnB
//-----------------------------------------------------------------------------

#define PBF_TYPE_MONO			0x01	// mNC[W
#define PBF_TYPE_GRAYSCALE		0x02	// O[XP[
#define PBF_TYPE_INDEXCOLOR		0x04	// CfbNXJ[
#define PBF_TYPE_FULLCOLOR		0x08	// tJ[

#define PBF_REFERENCE_IMAGE		0x10	// C[Wf[^Q


///////////////////////////////////////////////////////////////////////////////
// tB^vOC̃}XN萔
//-----------------------------------------------------------------------------
// tB^͏̌ʂ}XN̈ɉă}XN邩ǂI邱Ƃ
// BPFilterImage::dwMaskFlag Ŏw肷邱ƁBftHg PBF_MASK_CLIENT
// łB
//-----------------------------------------------------------------------------

#define PBF_MASK_CLIENT			0x00	// }XN PictBear 
#define PBF_MASK_PLUGIN			0x01	// }XN̓vOC


///////////////////////////////////////////////////////////////////////////////
// tB^vOC Version 0 p̐is󋵂ʒm֐
//-----------------------------------------------------------------------------
// PictBear Version 1.xx nƂ̌݊płB
//-----------------------------------------------------------------------------

typedef int (WINAPI *PBF_ProgressCallback)(int, int, long);


///////////////////////////////////////////////////////////////////////////////
// PBF_QueryClientInfo (PictBear e𓾂)
//-----------------------------------------------------------------------------
// PictBear Version 1.xx nƂ̌݊płB
// PictBear Second Edition ł PFilterImage/PProvidedFunc 擾邱ƁB
//-----------------------------------------------------------------------------

typedef BOOL (WINAPI* PBF_QueryClientInfoProc)(DWORD, void*);

#define PBF_QUERY_VERSION		0x00	// int    : PictBear ̃o[W
#define PBF_QUERY_DRAWCOLOR		0x01	// Pixel32: `F
#define PBF_QUERY_BKGNDCOLOR	0x03	// Pixel32: wiFia ̒l͕sj
#define PBF_QUERY_FGCOLOR		0x01	// PBF_QUERY_DRAWCOLOR Ɠ
#define PBF_QUERY_BGCOLOR		0x03	// PBF_QUERY_BKGNDCOLOR Ɠ

// ȉ PictBear Second Edition ȍ~ł̓T|[gĂ܂B

// PictBear Version 1.40 ȍ~ŃT|[g(QUERY_VERSION ł͔fs)
#define PBF_QUERY_MASK			0x04	// BYTE*  : }XN̈ւ̃|C^
#define PBF_QUERY_ABORT			0x05	// p[^

// PictBear Version 1.60 ȍ~ŃT|[g
#define PBF_QUERY_EDIT_MODE		0x06	// BYTE   : MASK==0, IMAGE==1


///////////////////////////////////////////////////////////////////////////////
// GNX|[gvOC̑ΉtH[}bg萔
//-----------------------------------------------------------------------------
// GNX|[gvOC͑ΉĂC[W^Cv萔 
// PBE_GetSupportedType ŕԂKvBC[T|[gɂ
// PBF_SUPPORT_LAYER AߐFT|[gɂ PBE_SUPPORT_TRANSPARENT 
// ݒ肵ĂB
//-----------------------------------------------------------------------------

#define PBE_TYPE_MONO			0x01	// mNC[W
#define PBE_TYPE_GRAYSCALE		0x02	// O[XP[
#define PBE_TYPE_INDEXCOLOR		0x04	// CfbNXJ[
#define PBE_TYPE_FULLCOLOR		0x08	// tJ[

#define PBE_SUPPORT_LAYER		0x10	// C[T|[g
#define PBE_SUPPORT_TRANSPARENT	0x20	// ߐFT|[g


//////////////////////////////////////////////////////////////////////////////
// C[[h
//-----------------------------------------------------------------------------
// PBF_REFERENCE_IMAGE w肵Ď擾C[Wێ郌C[̍@
// QƂɂ͈ȉ̒萔gpĂB
//-----------------------------------------------------------------------------

#define LM_NORMAL		0x00	// ʏ
#define LM_PLUS			0x01	// Z
#define LM_MINUS		0x02	// Z
#define LM_TIMES		0x03	// Z
#define LM_SCREEN		0x04	// XN[
#define LM_OVERLAY		0x05	// I[o[C
#define LM_HARDLIGHT	0x06	// n[hCg
#define LM_SOFTLIGHT	0x07	// \tgCg
#define LM_OVER			0x08	// Ă
#define LM_FIRE			0x09	// Ă
#define LM_CMPLIGHT		0x0A	// r()
#define LM_CMPDARK		0x0B	// r()
#define LM_ABS			0x0C	// ̐Βl
#define LM_EXCEPT		0x0D	// O
#define LM_VIVIDLIGHT	0x0E	// rrbgCg
#define LM_LINEARLIGHT	0x0F	// jACg
#define LM_PINLIGHT		0x10	// sCg


//////////////////////////////////////////////////////////////////////////////
// C[W^Cv
//-----------------------------------------------------------------------------
// PFilterImage::nImageType Ɋi[ĂC[W^Cvp萔łB
//-----------------------------------------------------------------------------

#define IT_MONO			0x01	// mN
#define IT_GRAYSCALE	0x02	// O[XP[
#define IT_INDEXCOLOR	0x03	// CfbNX[h	
#define IT_FULLCOLOR	0x04	// tJ[


//////////////////////////////////////////////////////////////////////////////
// C[\
//-----------------------------------------------------------------------------
// C|[gvOC͒ڃANZXɕK PProvidedFunc oRŃANZX
// ĂB
//-----------------------------------------------------------------------------

#pragma pack(1)

typedef struct tagPLayer
{
	int    cbSize;			// \̃TCY

	char   szName[1024];	// C[
	int    nLayerMode;		// [h(LM_???)
	int    bVisible;		// 
	int    nOpacity;		// sx
	int    nLeft;			// ItZbg
	int    nTop;			// ItZbg
	int    nWidth;			// 
	int    nHeight;			// 
	DWORD* pData;			// C[f[^

	BYTE   Reserved[32];	// \ς݃f[^
} PLayer;

#pragma pack()


//////////////////////////////////////////////////////////////////////////////
// C[W\
//-----------------------------------------------------------------------------
// C|[gvOC͒ڃANZXɕK PProvidedFunc oRŃANZX
// ĂB
//-----------------------------------------------------------------------------

#pragma pack(1)

typedef struct tagPImage
{
	int     cbSize;				// \̃TCY

	int     nImageType;			// C[W^Cv(IT_???)
	PLayer* pLayer;				// C[ff[^
	int     nLayerCount;		// C[̐ (1 ` )
	int     nWidth;				// C[W̕
	int     nHeight;			// C[W̍
	int     bEnableBg;			// wiC[gp邩(IT_FULLCOLOR)
	int     nDPI;				// DPI
	Pixel32 rgbPalettes[256];	// pbg
	int     nPaletteSize;		// pbgTCY(1 ` 256)
	int     nTransparent;		// ߐFԍ(0 ` nPaletteSize-1)
	int     bEnableTrans;		// ߐFL
	int     nCurrentLayer;		// JgC[(0 ` nLayerCount-1)

	BYTE    Reserved[32];		// \ς݃f[^
} PImage;


///////////////////////////////////////////////////////////////////////////////
// tB^pC[Wf[^\

typedef struct tagPFilterImage
{
	int     cbSize;			// \̃TCY

	int     nWidth;			// ^[QbgC[̕
	int     nHeight;		// ^[QbgC[̍
	int     nTargetLayer;	// tB^Kp郌C[
	DWORD*  pSrc;			// ^[QbgC[f[^
	DWORD*  pDst;			// ʏݗpf[^
	BOOL    bMaskMode;		// }XN[h(false=ʏ탂[h, true=}XN[h)
	BYTE*   pMask;			// }XNf[^(}XN[hׂ͂ă[)
	DWORD   dwMaskFlag;		// }XN̏@(PBF_MASK_CLIENT/PBF_MASK_PLUGIN)
	RECT    rcSelection;	// I͈̗͂̈(MEMO:ItZbgl***************)
	PImage* pSrcImage;		// QƗpC[W (PBF_REFERENCE_IMAGE w肳ĂȂƂ NULL)
	LPSTR*  szArgs;			// XNvgĂ΂ꂽƂ̈
	int     nArgCount;		// ̐(ʏĂяo 0)
	DWORD	dwImageType;	// C[W[h(IT_???)

	BYTE    Reserved[32];	// \̈
} PFilterImage;


//////////////////////////////////////////////////////////////////////////////
// NCAg񋟂֐

typedef void  (WINAPI *PB_CreateMono)(PImage* pImage, int nWidth, int Height);
typedef void  (WINAPI *PB_CreateGrayScale)(PImage* pImage, int nWidth, int nHeight);
typedef void  (WINAPI *PB_CreateIndexColor)(PImage* pImage, int nWidth, int nHeight);
typedef void  (WINAPI *PB_CreateFullColor)(PImage* pImage, int nWidth, int nHeight, int nLayer, int bEnableBgLayer);

typedef void  (WINAPI *PB_ResizeLayer)(PImage* pImage, int nLayer, int nWidth, int nHeight, int nLeftOffset, int nTopOffset);

typedef void  (WINAPI *PB_SetData)(PImage* pImage, int nLayer, int x, int y, DWORD dwData);
typedef DWORD (WINAPI *PB_GetData)(PImage* pImage, int nLayer, int x, int y);

typedef void  (WINAPI *PB_ProgressStart)(int nMin, int nMax);
typedef int   (WINAPI *PB_ProgressSetPos)(int nPos);
typedef void  (WINAPI *PB_ProgressEnd)();

typedef void* (WINAPI *PB_Alloc)(int nSize);
typedef void  (WINAPI *PB_Free)(void* pData);

typedef BOOL  (WINAPI *PB_ChooseColor)(HWND hWnd, Pixel32* pColor);

typedef void  (WINAPI *PB_WriteInteger)(LPCSTR szSection, LPCSTR szKey, int nValue);
typedef void  (WINAPI *PB_WriteString) (LPCSTR szSection, LPCSTR szKey, LPCSTR szBuf);
typedef void  (WINAPI *PB_GetInteger)  (LPCSTR szSection, LPCSTR szKey, int* pResult, int nDefault);
typedef void  (WINAPI *PB_GetString)   (LPCSTR szSection, LPCSTR szKey, LPSTR szBuf, int nSize, LPCSTR szDefault);

typedef int   (WINAPI *PB_GetVersion)  ();
typedef void  (WINAPI *PB_GetFgColor)  (Pixel32* pColor);
typedef void  (WINAPI *PB_GetBgColor)  (Pixel32* pColor);
typedef void  (WINAPI *PB_GetLanguage) (LPSTR szLang, int nSize);


#pragma pack(1)

typedef struct tagPProvidedFunc
{
	int					    cbSize;				// \̃TCY

	PB_CreateMono			CreateMono;			// mNC[W̍쐬
	PB_CreateGrayScale		CreateGrayScale;	// O[XP[C[W̍쐬
	PB_CreateIndexColor		CreateIndexColor;	// CfbNXJ[C[W̍쐬
	PB_CreateFullColor		CreateFullColor;	// tJ[C[W̍쐬
	PB_ResizeLayer			ResizeLayer;		// C[̃TCYύX
	PB_SetData				SetData;			// C[Ƀf[^
	PB_GetData				GetData;			// C[f[^ǂݍ
	PB_ChooseColor			ChooseColor;		// FI_CAO\
	PB_ProgressStart		ProgressStart;		// is󋵒ʒmJn
	PB_ProgressSetPos		ProgressSetPos;		// is󋵒ʒm
	PB_ProgressEnd			ProgressEnd;		// is󋵒ʒmI
	PB_Alloc				Alloc;				// m
	PB_Free					Free;				// J
	PB_WriteInteger			WriteInteger;		// Plugins.ini ɐo
	PB_WriteString			WriteString;		// Plugins.ini ɕ񏑂o
	PB_GetInteger			GetInteger;			// Plugins.ini 琮擾
	PB_GetString			GetString;			// Plugins.ini 當擾
	PB_GetVersion			GetVersion;			// NCAg̃o[W擾
	PB_GetFgColor			GetFgColor;			// `F擾
	PB_GetBgColor			GetBgColor;			// wiF擾
	PB_GetLanguage			GetLanguage;		// gp擾

	BYTE					Reserved[44];		// \ς݃f[^
} PProvidedFunc;

#pragma pack()


#ifdef __cplusplus
}
#endif


#endif // __PBPLUGIN_H
//-----------------------------------------------------------------------------
