//-----------------------------------------------------------------------------
// PictBear Export Bitmap Plugin
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//
// $Version 1.00 [2003/05/07]
//
// Windows Bitmap ۑGNX|[gvOCłB
//
// Visual C++ 6.0 ł̓mFĂ܂B
// >cl /LD /FeexpBmp.ppi expBmp.c
//
// ̃\[X̉ρEzz͎RɍsĂBsC͑劽}łB
//-----------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "../../PbPlugin.h"

#ifdef __cplusplus
#define DLLExport extern "C" __declspec (dllexport)
#else
#define DLLExport __declspec (dllexport)
#endif


// TODO: P̃vOCɂ͕̊gqo^ł܂B
//       o^gq̐`ĂB
#define SUPPORTED_TYPE_IN_PLUGIN 1

// TODO: Ήgq gq|p|{ Œ`ĂBgq
//       Ƀhbg͂ȂŉB̊gqo^ꍇ ';' ŋ؂
//       ĂB
//
//       gq̏ꍇ̓GNX|[gj[ɕ\܂B[[őM]
//       ̂悤Ƀt@CȊOɏo͂ꍇɗpł܂B
const char* g_szTypes[SUPPORTED_TYPE_IN_PLUGIN] = 
{
	"bmp;dib|Windows Bitmaps Files|Windows rbg}bvt@C"
};


// TODO: T|[gĂC[W^CvAyуIvV`ĂB 
//       PBE_Execute ɓn PImage ͂ꂩ̃f[^ł邱ƂNCA
//       gvOŕۏ؂܂B
//
//       C[gpĂtJ[C[W舵ꍇ 
//       PBE_SUPPORT_LAYER AߐF𗘗pCfbNXC[W舵
//        PBE_SUPPORT_TRANSPARENT w肵ĂB
DWORD g_dwFormats[SUPPORTED_TYPE_IN_PLUGIN] =
{
	PBE_TYPE_MONO | PBE_TYPE_GRAYSCALE | PBE_TYPE_INDEXCOLOR | PBE_TYPE_FULLCOLOR
};

// TODO: Cӂ̃Rs[Cgݒ肵ĂB
const char* g_szCopyright = "Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.";


HINSTANCE g_hInstance;


///////////////////////////////////////////////////////////////////////////////
// Gg[|Cg

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
		g_hInstance = hinstDLL;
	
	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// vOC擾

DLLExport WORD WINAPI PB_GetPluginInfo(LPSTR buf, int buflen)
{
	// TODO: buf ɃRs[Cgݒ肵Aȉ̒lԂĂB
	strncpy(buf, g_szCopyright, buflen);

	return MAKEWORD(PBPLUGIN_EXPORT, PBPLUGIN_EXPORT_VERSION);
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂgq̐擾

DLLExport int WINAPI PBE_GetCount(void)
{
	// TODO: vOCɑΉĂgq̐ԂĂB
	return SUPPORTED_TYPE_IN_PLUGIN;
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂt@C̏ڍׂ擾

DLLExport void WINAPI PBE_GetSupportedType(int nIndex, LPSTR szType, int nSize)
{
	// TODO: ΉĂgqݒ肵ĂB
	strncpy(szType, g_szTypes[nIndex], nSize);
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂC[W̎ނ擾

DLLExport DWORD WINAPI PBE_GetSupportedFormat(int nIndex)
{
	// TODO: ΉĂtH[}bgݒ肵ĂB
	return g_dwFormats[nIndex];
}


///////////////////////////////////////////////////////////////////////////////
// C|[gs

DLLExport int WINAPI PBE_Execute(int nIndex, HWND hWnd, LPCSTR szFileName, PImage* pImage, PProvidedFunc* pFunc)
{
	// TODO: GNX|[g̓eLqĂB
	//       PBE_Setup Őݒ肵f[^͂œǂݍłB

	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	FILE* fp;
	BYTE* buf;
	int   nPaletteSize;
	int   nLineNeed;
	int   nBitCount;
	int   nImageSize;
	int   nLeft   = pImage->pLayer[0].nLeft;
	int   nTop    = pImage->pLayer[0].nTop;
	int   nWidth  = pImage->pLayer[0].nWidth  - nLeft;
	int   nHeight = pImage->pLayer[0].nHeight - nTop;
	int   x, i;
	
	if ((fp = fopen(szFileName, "wb")) == NULL)
		return PB_ERR_FILE_CANNOT_CREATE;

	// F[x擾B
	switch (pImage->nImageType)
	{
	case IT_MONO:
		nBitCount = 1;
		nPaletteSize = 2;
		break;

	case IT_GRAYSCALE:
		nBitCount = 8;
		nPaletteSize = 256;
		break;

	case IT_INDEXCOLOR:
		nBitCount = 8;
		nPaletteSize = pImage->nPaletteSize;
		break;

	default:
		nBitCount = 24;
		nPaletteSize = 0;
	}

	// CpoCgvZADWORD 񉻂sB
	nLineNeed = (nWidth*nBitCount)/8;
	if (nLineNeed % 4)
		nLineNeed = ((nLineNeed/4) + 1)*4;

	// C[WTCYvZB
	nImageSize = nLineNeed * nHeight;

	// BITMAPFILEHEADER 쐬B
	bf.bfType      = 0x4d42;
	bf.bfSize      = sizeof(BITMAPINFOHEADER)+sizeof(BITMAPFILEHEADER)+nPaletteSize*sizeof(RGBQUAD)+nImageSize;
	bf.bfReserved1 = 0; // must be 0
	bf.bfReserved2 = 0; // must be 0
	bf.bfOffBits   = sizeof(BITMAPINFOHEADER)+sizeof(BITMAPFILEHEADER)+nPaletteSize*sizeof(RGBQUAD);

	// BITMAPINFOHEADER 쐬B
	bi.biSize          = sizeof(BITMAPINFOHEADER);
	bi.biWidth         = nWidth;
	bi.biHeight        = nHeight;
	bi.biPlanes        = 1; // must be 1
	bi.biBitCount      = nBitCount;
	bi.biCompression   = BI_RGB;
	bi.biSizeImage     = nImageSize;
	bi.biXPelsPerMeter = (int)(pImage->nDPI*39.375);
	bi.biYPelsPerMeter = (int)(pImage->nDPI*39.375); 
	bi.biClrUsed       = nPaletteSize;
	bi.biClrImportant  = 0;

	fwrite(&bf, sizeof(BITMAPFILEHEADER), 1, fp);
	fwrite(&bi, sizeof(BITMAPINFOHEADER), 1, fp);

	// pbg
	if (nPaletteSize > 0)
	{
		if (pImage->nImageType == IT_GRAYSCALE)
		{
			// O[XP[̏ꍇ̓CfbNX[hŃO[XP[
			// p̃pbg쐬AށB
			RGBQUAD pal[256];
			int i;

			for (i=0; i<256; i++)
			{
				pal[i].rgbRed      = i;
				pal[i].rgbGreen    = i;
				pal[i].rgbBlue     = i;
				pal[i].rgbReserved = 0;
			}
			fwrite(pal, sizeof(RGBQUAD), 256, fp);
		}
		else if (pImage->nImageType == IT_MONO)
		{
			// mN̏ꍇ͔̃pbg菑ށB
			RGBQUAD pal[2];

			pal[0].rgbRed      = 0;
			pal[0].rgbGreen    = 0;
			pal[0].rgbBlue     = 0;
			pal[0].rgbReserved = 0;

			pal[1].rgbRed      = 255;
			pal[1].rgbGreen    = 255;
			pal[1].rgbBlue     = 255;
			pal[1].rgbReserved = 0;

			fwrite(pal, sizeof(RGBQUAD), 2, fp);
		}
		else
		{
			RGBQUAD* pal = (RGBQUAD*)malloc(sizeof(RGBQUAD)*nPaletteSize);
			int i;

			for (i=0; i<nPaletteSize; i++)
			{
				pal[i].rgbRed      = pImage->rgbPalettes[i].item.r;
				pal[i].rgbGreen    = pImage->rgbPalettes[i].item.g;
				pal[i].rgbBlue     = pImage->rgbPalettes[i].item.b;
				pal[i].rgbReserved = 0;
			}
			fwrite(pal, sizeof(RGBQUAD), nPaletteSize, fp);

			free(pal);
		}
	}

	pFunc->ProgressStart(0, nHeight);

	buf = (BYTE*)malloc(sizeof(BYTE)*nLineNeed);

	for (i=0; i<nHeight; i++)
	{
		int y = nHeight - i - 1;

		// F[xɉ͂sB
		switch (nBitCount) 
		{
		case 1:	
			for (x=0; x<(nWidth + 7)/8; x++)
			{
				BYTE dat = 0;
				int bit;

				for (bit=0; bit<8; bit++)
				{
					if (x*8+bit < nWidth)
					{
						DWORD dwData = pFunc->GetData(pImage, 0, nLeft + x*8 + bit, nTop + y);
						dat = (dat<<1)|(dwData?1:0);
					}
					else
					{
						dat <<= 1;
					}
				}
				buf[x] = dat;
			}
			break;

		case 8:
			for (x=0; x<nWidth; x++)
			{
				buf[x] = (BYTE)pFunc->GetData(pImage, 0, nLeft + x, nTop + y);
			}
			break;

		default:
			for (x=0; x<nWidth; x++)
			{
				Pixel32 pix;
				pix.color = pFunc->GetData(pImage, 0, nLeft + x, nTop + y);

				buf[x*3+0] = pix.item.b;
				buf[x*3+1] = pix.item.g;
				buf[x*3+2] = pix.item.r;
			}
			break;
		}

		if (fwrite(buf, sizeof(BYTE), nLineNeed, fp) != (size_t)nLineNeed)
		{
			free(buf);
			fclose(fp);
			pFunc->ProgressEnd();

			return PB_ERR_WRITE_ERROR;
		}

		pFunc->ProgressSetPos(i);
	}

	free(buf);
	fclose(fp);

	pFunc->ProgressEnd();

	return PB_ERR_SUCCESS;
}


///////////////////////////////////////////////////////////////////////////////
// vOC̐ݒ

/*

DLLExport void WINAPI PBE_Setup(HWND hWnd, PProvidedFunc* pFunc)
{
	// TODO: vOC̐ݒs܂B
}

*/

///////////////////////////////////////////////////////////////////////////////
// Visual C++ p GNX|[g̕ϊ

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:PB_GetPluginInfo=_PB_GetPluginInfo@8")
#pragma comment(linker, "/EXPORT:PBE_GetCount=_PBE_GetCount@0")
#pragma comment(linker, "/EXPORT:PBE_GetSupportedType=_PBE_GetSupportedType@12")
#pragma comment(linker, "/EXPORT:PBE_GetSupportedFormat=_PBE_GetSupportedFormat@4")
#pragma comment(linker, "/EXPORT:PBE_Execute=_PBE_Execute@20")
//#pragma comment(linker, "/EXPORT:PBE_Setup=_PBE_Setup@8")
#endif

