(*
	PictBearpvOC
	DelphiTv
	Copyright(c) 2001/12/16 M&I
	mailto:masahiro.inoue@nifty.ne.jp
	http://member.nifty.ne.jp/m-and-i/
*)
unit Generic;

interface

uses
	Windows, SysUtils;

type
  // sNZ\
	TPixel32 = record
		b,              // 
		g,              // 
		r,              // 
		a: Byte;        // sx
	end;
	PPixel32 = ^TPixel32;
	PByte    = ^Byte;
	PDword   = ^DWord;
	PRect    = ^TRect;
	// R[obN֐
	PBF_ProgressCallback = function(Pos, Max: integer; Data:integer): integer; stdcall;
	PBF_QueryClientInfoProc = function(Data:DWORD; Addr: PChar): BOOL; stdcall;

const
	PBPLUGIN_VERSION    = $01;  // vOC̃o[Wԍ
	PBPLUGIN_UNKNOWN    = $00;  // sȃvOC
	PBPLUGIN_FILTER     = $01;  // tB^vOC
	PBF_MASK_CLIENT     = $00;  // }XN PictBear 
	PBF_MASK_PLUGIN     = $01;  // }XN̓vOC
	PBF_QUERY_VERSION   = $00;  // PictBear ̃o[W
	PBF_QUERY_DRAWCOLOR = $01;  // Pixel32 : GF
	PBF_QUERY_SUBCOLOR  = $02;  // Pixel32 : ⏕Fiݎgpsj
	PBF_QUERY_BKGNDCOLOR= $03;  // Pixel32 : wiFia ̒l͕sj

	FILTER_IN_PLUGIN    = 3;		// ܂܂vOC̐
	g_szCopyright       = 'Copyright(c) 2001 M&&I';

// vOC̎ނƖO
var
	g_szKind: array[0..2] of string =
						('Sample|','Sample|','Sample|');
	g_szName: array[0..2] of string =
						('Nega|]','GrayScale|ڰ','Bin|2l');

function PB_GetPluginInfo(buf: PChar;	buflen: integer): WORD; stdcall;
function PBF_FilterCount: integer; stdcall;
procedure PBF_GetName(no: integer; kind: PChar; kind_len: integer;
					name: PChar; name_len: integer); stdcall;
procedure PBF_Execute(no: integer; hwnd: HWND; const src: PPixel32; dst: PPixel32;
					mask: PByte; area: PRect; maskflag: PDWORD; width, height: integer;    //* C[̍ */
					proc: FarProc; data: integer); stdcall
function PBF_Setup(no: integer; hwnd: HWND; const image: PPixel32;
	        width, height: integer): Boolean; stdcall;

					
implementation


// vOC擾 ------------------------------------------------
function PB_GetPluginInfo(
	buf: PChar;       	// Rs[Cgi[pobt@
	buflen: integer			// buf ̑傫
	): WORD; stdcall;
begin
	// NOTE: buf ɃRs[Cgݒ肵Aȉ̒lԂĂ
	StrLCopy(buf, g_szCopyright, buflen);
	Result := PBPLUGIN_FILTER and (PBPLUGIN_VERSION shl 8);
end;

// tB^擾 ----------------------------------------------------
function PBF_FilterCount: integer; stdcall;
begin
	// NOTE: vOCɊ܂܂tB^̐ԂĂ
	Result := FILTER_IN_PLUGIN;
end;

// tB^̎ނƖO̎擾 ----------------------------------------
procedure PBF_GetName(
	no: integer;        // tB^ԍ
	kind: PChar;        // tB^̎ފi[pobt@
	kind_len: integer;	// kind ̑傫
	name: PChar;        // tB^̖Oi[pobt@
	name_len: integer   // name ̑傫
	); stdcall;
begin
	// NOTE: kind ɃtB^̎ށAname ɃtB^ݒ肵Ă
	StrLCopy(kind, PChar(g_szKind[no]), kind_len);
	StrLCopy(name, PChar(g_szName[no]), name_len);
end;

// tB^s ------------------------------------------------------
procedure PBF_Execute(
	no: integer;        // tB^ԍ
	hwnd: HWND;         // EChEnh
	const src: PPixel32;
	dst: PPixel32;			// QƗpC[
	mask: PByte;        // }XNf[^
	area: PRect;       	// tB^Kp͈
	maskflag: PDWORD;   // }XN@
	width,              // C[̕
	height: integer;    // C[̍
	proc: FarProc;      // is󋵕񍐃R[obN֐
	data: integer       // R[obN֐pf[^
	); stdcall;
var
  x1, x2, y1, y2,
	x, y: integer;
	progress: PBF_ProgressCallback;
	ps, pd: PPixel32;
begin
	// NOTE: tB^̎s(ڂ͂̑̃tB^QlĂ)
	progress := proc;

	x1 := area^.left;
	y1 := area^.top;
	x2 := area^.right;
	y2 := area^.bottom;

	// sꂽj[Noɂ鏈̕
	case no of
		0:
			begin
				for y := y1 to y2 - 1 do
					for x := x1 to x2 - 1 do
					begin
						ps := src;
						pd := dst;
						Inc(ps, x+y*width);
						Inc(pd, x+y*width);
						pd^.r := 255 - ps^.r;
						pd^.g := 255 - ps^.g;
						pd^.b := 255 - ps^.b;
						pd^.a := ps^.a;
						progress(0, y-y1, data);
					end;
			end;
		1, 2:	MessageBox(hInstance, 'g͂Ȃ(^^;', '', 0);
	end;
	progress(y2-y1, y2-y1, data);
end;

// tB^ݒ ------------------------------------------------------
function PBF_Setup(
	no: integer;          // tB^ԍ
	hwnd: HWND;           // EChEnh
	const image: PPixel32;// vr[C[
	width,                // C[̕
	height: integer       // C[̍
	): Boolean; stdcall;
begin
	// NOTE: ݒsꍇ͈ȉ̂悤ȏsĂ

	(*----- SAMPLE ---------------
	ݒǂݍ
	if ݒ肪ύX then
		ݒۑ
		Result := TRUE
	else
	  Result := FALSE;
	----------------------------*)

	// NOTE: ݒsȂꍇ TRUE ԂĂ
	Result := TRUE;
end;

end.
