//-----------------------------------------------------------------------------
// PictBear Sample Filter Plugin
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//
// SDK p̃TvtB^łB
//
// Borland C++ Compiler 5.5AVC6 ł̓mFĂ܂B
// >bcc32 -tWD -eGeneric.ppi Generic.c
// >cl /LD /FeGeneric.ppi Generic.c
//
// C++ g GenFilter.h gpƌIɃtB^쐬邱
// Ƃł܂Bڂ Mask/Block tB^̃\[XQƂĉB
//
// ̃\[X̉ρEzz͎RɍsĂB
//-----------------------------------------------------------------------------

#include <windows.h>
#include "PbPlugin.h"

#ifdef __cplusplus
#define DLLExport extern "C" __declspec (dllexport)
#else
#define DLLExport __declspec (dllexport)
#endif


// TODO: P̃vOCɂ͕̃tB^o^ł܂B
//       o^tB^̐`ĂB
#define FILTER_IN_PLUGIN 3

// TODO: tB^̎ނ p\L|{\L Œ`ĂB
//       Ȃׂłɂނ̖OgpĂB
const char* g_szKinds[FILTER_IN_PLUGIN] = 
{
	"Sample|Tv",
	"Sample|Tv",
	"Sample|Tv"
};

// TODO: tB^ p\L|{\L Œ`ĂB
const char* g_szNames[FILTER_IN_PLUGIN] = 
{
	"Red|",
	"Green|",
	"Blue|"
};


// TODO: Cӂ̃Rs[Cgݒ肵ĂB
const char* g_szCopyright = "Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.";


HINSTANCE g_hInstance;


///////////////////////////////////////////////////////////////////////////////
// Gg[|Cg

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
	{
		g_hInstance = hinstDLL;
	}
	
	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// vOC擾

DLLExport WORD WINAPI PB_GetPluginInfo(LPSTR buf, int buflen)
{
	// TODO: buf ɃRs[Cgݒ肵Aȉ̒lԂĂB
	strncpy(buf, g_szCopyright, buflen);

	return MAKEWORD(PBPLUGIN_FILTER, PBPLUGIN_FILTER_VERSION);
}


///////////////////////////////////////////////////////////////////////////////
// tB^擾

DLLExport int WINAPI PBF_FilterCount(void)
{
	// TODO: vOCɊ܂܂tB^̐ԂĂB
	return FILTER_IN_PLUGIN;
}


///////////////////////////////////////////////////////////////////////////////
// tB^̎ނƖO̎擾

DLLExport void WINAPI PBF_GetName(int no, LPSTR kind, int kind_len, LPSTR name, int name_len)
{
	// TODO: kind ɃtB^̎ށAname ɃtB^ݒ肵ĂB
	strncpy(kind, g_szKinds[no], kind_len);
	strncpy(name, g_szNames[no], name_len);
}


///////////////////////////////////////////////////////////////////////////////
// tB^s

DLLExport void WINAPI PBF_Execute(
		int no,             // tB^ԍ
		HWND hwnd,          // EChEnh
		const Pixel32* src, // QƗpC[
		Pixel32* dst,       // ʗpC[
		BYTE* mask,         // }XNf[^
		RECT* area,         // tB^Kp͈
		DWORD* maskflag,    // }XN@
		int width,          // C[̕
		int height,         // C[̍
		FARPROC proc,       // is󋵕񍐃R[obN֐
		long data)          // R[obN֐pf[^
{
	// TODO: tB^̓eLqĂB
	//       (ڂ͂̑̃tB^QlĂ)
	PBF_ProgressCallback progress = (PBF_ProgressCallback)proc;
	int x1 = area->left;
	int y1 = area->top;
	int x2 = area->right;
	int y2 = area->bottom;
	int x, y;

	if (progress)
		progress(0, y2 - y1, data);

	for (y=y1; y<y2; y++) 
	{
		for (x=x1; x<x2; x++) 
		{
			const Pixel32* sp = &src[x + y*width];
			Pixel32* dp       = &dst[x + y*width];
			int gray          = (sp->item.r + sp->item.g + sp->item.b)/3;

			switch (no) 
			{
			case 0: /* Red */
				dp->item.r = gray;
				dp->item.g = 0;
				dp->item.b = 0;
				dp->item.a = sp->item.a;
				break;

			case 1: /* Green */
				dp->item.r = 0;
				dp->item.g = gray;
				dp->item.b = 0;
				dp->item.a = sp->item.a;
				break;

			case 2: /* Blue */
				dp->item.r = 0;
				dp->item.g = 0;
				dp->item.b = gray;
				dp->item.a = sp->item.a;
				break;
			}
		}

		if (progress)
			progress(y - y1, y2 - y1, data);
	}

	if (progress)
		progress(y2 - y1, y2 - y1, data);
}


///////////////////////////////////////////////////////////////////////////////
// tB^ݒ

DLLExport BOOL WINAPI PBF_Setup(int no, HWND hwnd, const Pixel32* image, int width, int height)
{
	// TODO: tB^̐ݒsꍇ͈ȉ̂悤ȏsĂB
	//
	//       (1) ݒǂݍށB
	//       (2) ݒ_CAO\B
	//       (3) ݒ肪ύXꂽꍇ͐ݒۑATRUE ԂB
	//       (4) LZꂽꍇ FALSE ԂĂB
	//
	//       ݒsȂꍇ TRUE ԂĂB

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// Visual C++ p GNX|[g̕ϊ

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:PB_GetPluginInfo=_PB_GetPluginInfo@8")
#pragma comment(linker, "/EXPORT:PBF_FilterCount=_PBF_FilterCount@0")
#pragma comment(linker, "/EXPORT:PBF_GetName=_PBF_GetName@20")
#pragma comment(linker, "/EXPORT:PBF_Setup=_PBF_Setup@20")
#pragma comment(linker, "/EXPORT:PBF_Execute=_PBF_Execute@44")
#endif

