//-----------------------------------------------------------------------------
// Blur Filters
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "Blur.h"


SoftBlurFilter::SoftBlurFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 0, 1, 0, 0,
		0, 1, 8, 1, 0,
		0, 0, 1, 0, 0,
		0, 0, 0, 0, 0 
	};

	SetKind("Blur|ڂ");
	SetName("Soft blur|ڂ");
	SetKernel(kernel);
	SetScale(12);
	SetOffset(0);
}

HardBlurFilter::HardBlurFilter()
{
	int kernel[25] = 
	{
		0, 1, 2, 1, 0,
		1, 2, 4, 2, 1,
		2, 4, 8, 4, 2,
		1, 2, 4, 2, 1,
		0, 1, 2, 1, 0
	};

	SetKind("Blur|ڂ");
	SetName("Hard blur|ڂ");
	SetKernel(kernel);
	SetScale(48);
	SetOffset(0);
}
