//-----------------------------------------------------------------------------
// Standard Filters for V1 Format
// $Version 1.7 (04/05/03)
// Copyright (C) 2000-2004 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "GenFilter.h"
#include "Blur.h"
#include "Sharp.h"
#include "Mosaic.h"
#include "Edge.h"
#include "Color.h"
#include "Special.h"


BEGIN_FILTER_MAP()
	DECLARE_COPYRIGHT("Copyright (C) 2000-2004 by Yasuyuki Kashiwagi. All Rights Reserved.")
	DECLARE_FILTER(SoftBlurFilter)
	DECLARE_FILTER(HardBlurFilter)
	DECLARE_FILTER(SoftSharpFilter)
	DECLARE_FILTER(HardSharpFilter)
	DECLARE_FILTER(EdgePrewittFilter)
	DECLARE_FILTER(EdgeLaplacianFilter)
	DECLARE_FILTER(ReverseFilter)
	DECLARE_FILTER(ContrastPlusFilter)
	DECLARE_FILTER(ContrastMinusFilter)
	DECLARE_FILTER(GrayScaleFilter)
	DECLARE_FILTER(EmbossFilter)
	DECLARE_FILTER(BlowFilter)
	DECLARE_FILTER(MosaicFilter)
END_FILTER_MAP()

