//-----------------------------------------------------------------------------
// Sharp Filters
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "Sharp.h"


SoftSharpFilter::SoftSharpFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 0,-1, 0, 0,
		0,-1,16,-1, 0,
		0, 0,-1, 0, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Sharp|V[v");
	SetName("Soft sharp|V[v");
	SetKernel(kernel);
	SetScale(12);
	SetOffset(0);
}

HardSharpFilter::HardSharpFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0,-1,-2,-1, 0,
		0,-2,16,-2, 0,
		0,-1,-2,-1, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Sharp|V[v");
	SetName("Hard sharp|V[v");
	SetKernel(kernel);
	SetScale(4);
	SetOffset(0);
}
