//-----------------------------------------------------------------------------
// PictBear Cut Red Color Plugin
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//
// $Version 1.00 [2004/04/20]
//
// Ԑ菜vOCłB
//
// ̃\[X̉ρEzz͎RɍsĂBsC͑劽}łB
//-----------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "../../../../PbPlugin.h"

#ifdef __cplusplus
#define DLLExport extern "C" __declspec (dllexport)
#else
#define DLLExport __declspec (dllexport)
#endif

// vg^Cv錾
int ExecMono(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc);
int ExecGrayScale(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc);
int ExecIndexColor(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc);
int ExecFullColor(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc);

// TODO: P̃vOCɂ͕̃tB^o^ł܂B
//       o^tB^̐`ĂB
#define FILTER_IN_PLUGIN 1

// TODO: tB^̎ނ p\L|{\L Œ`ĂB
const char* g_szKinds[FILTER_IN_PLUGIN] = 
{
	"Color|J["
};

// TODO: tB^̖O p\L|{\L Œ`ĂB
const char* g_szNames[FILTER_IN_PLUGIN] = 
{
	"Cut Red Color|Ԑ̃NA_V2"
};

// TODO: T|[gĂC[W^CvAyуIvV`ĂB 
//
//       C[WŜQƂɂ PBF_REFERENCE_IMAGE w肵ĂBJ
//       gC[ƃ^[QbgC[͈قȂ邱Ƃ܂BtB^
//       ^[QbgC[ɑ΂Ă̂ݍsĂB
DWORD g_dwFormats[FILTER_IN_PLUGIN] =
{
	/*PBF_TYPE_MONO | PBF_TYPE_GRAYSCALE | PBF_TYPE_INDEXCOLOR | */PBF_TYPE_FULLCOLOR /*| PBF_REFERENCE_IMAGE*/
};


// TODO: Cӂ̃Rs[Cgݒ肵ĂB
const char* g_szCopyright = "Copyright (C) 2003-2004 by Yasuyuki Kashiwagi. All Rights Reserved.";

HINSTANCE g_hInstance;


///////////////////////////////////////////////////////////////////////////////
// Gg|Cg

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
	{
		g_hInstance = hinstDLL;
	}
	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// vOC擾

DLLExport WORD WINAPI PB_GetPluginInfo(LPSTR buf, int buflen)
{
	// TODO: buf ɃRs[Cgݒ肵Aȉ̒lԂĂB
	strncpy(buf, g_szCopyright, buflen);
	return MAKEWORD(PBPLUGIN_FILTER, PBPLUGIN_FILTER_VERSION);
}


///////////////////////////////////////////////////////////////////////////////
// tB^擾

DLLExport int WINAPI PBF_FilterCount(void)
{
	// TODO: vOCɊ܂܂tB^̐ԂĂB
	return FILTER_IN_PLUGIN;
}


///////////////////////////////////////////////////////////////////////////////
// tB^̎ނƖO̎擾

DLLExport void WINAPI PBF_GetName(int nIndex, LPSTR pszKind, int nKindLen, LPSTR pszName, int nNameLen)
{
	// TODO: kind ɃtB^̎ށAname ɃtB^ݒ肵ĂB
	strncpy(pszKind, g_szKinds[nIndex], nKindLen);
	strncpy(pszName, g_szNames[nIndex], nNameLen);
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂC[W̎ނ擾

DLLExport DWORD WINAPI PBF_GetSupportedFormat(int nIndex)
{
	// TODO: ΉĂtH[}bgݒ肵ĂB
	return g_dwFormats[nIndex];
}


///////////////////////////////////////////////////////////////////////////////
// tB^s

DLLExport int WINAPI PBF_Execute(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	// TODO: tB^̓eLqĂB
	pFunc->ProgressStart(0, pFilterImage->nHeight);

	switch (pFilterImage->dwImageType)
	{
	case IT_MONO:
		ExecMono(nIndex, hWnd, pFilterImage, pFunc);
		break;
		
	case IT_GRAYSCALE:
		ExecGrayScale(nIndex, hWnd, pFilterImage, pFunc);
		break;
		
	case IT_INDEXCOLOR:
		ExecIndexColor(nIndex, hWnd, pFilterImage, pFunc);
		break;
		
	case IT_FULLCOLOR:
		ExecFullColor(nIndex, hWnd, pFilterImage, pFunc);
		break;
	}
	
	pFunc->ProgressEnd();

	return PB_ERR_SUCCESS;
}

///////////////////////////////////////////////////////////////////////////////
// tB^ݒ

DLLExport BOOL WINAPI PBF_Setup(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	// TODO: vOC̐ݒs܂B
	//
	//       (1) ݒǂݍ
	//       (2) if (ݒ肪ύX) {
	//       (3)     ݒۑ
	//       (4)     return TRUE;
	//       (5) }
	//       (6) return FALSE;
	//
	//       ݒsȂꍇ TRUE ԂĂB

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// GNX|[g̕ϊ

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:PB_GetPluginInfo=_PB_GetPluginInfo@8")
#pragma comment(linker, "/EXPORT:PBF_FilterCount=_PBF_FilterCount@0")
#pragma comment(linker, "/EXPORT:PBF_GetName=_PBF_GetName@20")
#pragma comment(linker, "/EXPORT:PBF_GetSupportedFormat=_PBF_GetSupportedFormat@4")
#pragma comment(linker, "/EXPORT:PBF_Setup=_PBF_Setup@16")
#pragma comment(linker, "/EXPORT:PBF_Execute=_PBF_Execute@16")
#endif



//-----------------------------------------------------------------------------
// @\Cvg
//-----------------------------------------------------------------------------

// mN
int ExecMono(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	return 0;
}

// O[XP[
int ExecGrayScale(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	return 0;
}

// CfbNXJ[
int ExecIndexColor(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	// No impl...
	return 0;
}

// tJ[
int ExecFullColor(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	int x, y;

	for (y=0; y<pFilterImage->nHeight; y++) 
	{
		for (x=0; x<pFilterImage->nWidth; x++) 
		{
			Pixel32 pixel;
			pixel.color = pFilterImage->pSrc[x + y*pFilterImage->nWidth];
			pixel.item.r = 0;
			pixel.item.g = pixel.item.g;
			pixel.item.b = pixel.item.b;
			pixel.item.a = pixel.item.a;

			pFilterImage->pDst[x + y*pFilterImage->nWidth] = pixel.color;
		}

		pFunc->ProgressSetPos(y);
	}

	return 0;
}

