//-----------------------------------------------------------------------------
// PictBear Sample Filter Plugin
// Copyright (C) 2000-2004 by Yasuyuki Kashiwagi. All Rights Reserved.
//
// PDK p̃TvtB^łB
//
// Borland C++ Compiler 5.5AVC6 ł̓mFĂ܂B
// >bcc32 -tWD -eGeneric.ppi Generic.c
// >cl /LD /FeGeneric.ppi Generic.c
//
// C++ g GenFilter.h gpƌIɃtB^쐬邱
// Ƃł܂Bڂ Mask/Block tB^̃\[XQƂĉB
//
// ̃\[X̉ρEzz͎RɍsĂB
//-----------------------------------------------------------------------------

#include <windows.h>
#include "../../../../PbPlugin.h"

#ifdef __cplusplus
#define DLLExport extern "C" __declspec (dllexport)
#else
#define DLLExport __declspec (dllexport)
#endif


// TODO: P̃vOCɂ͕̃tB^o^ł܂B
//       o^tB^̐`ĂB
#define FILTER_IN_PLUGIN 3

// TODO: tB^̎ނ p\L|{\L Œ`ĂB
//       Ȃׂłɂނ̖OgpĂB
const char* g_szKinds[FILTER_IN_PLUGIN] = 
{
	"Sample Plugins|TvvOC",
	"Sample Plugins|TvvOC",
	"Sample Plugins|TvvOC"
};

// TODO: tB^ p\L|{\L Œ`ĂB
const char* g_szNames[FILTER_IN_PLUGIN] = 
{
	"Get Red Value|Ԑ̂ݎ擾",
	"Get Green Value|ΐ̂ݎ擾",
	"Get Blue Value|̂ݎ擾"
};


// TODO: T|[gĂC[W^CvAyуIvV`ĂB 
//
//       C[WŜQƂɂ PBF_REFERENCE_IMAGE w肵ĂBJ
//       gC[ƃ^[QbgC[͈قȂ邱Ƃ܂BtB^
//       ^[QbgC[ɑ΂Ă̂ݍsĂB
DWORD g_dwFormats[FILTER_IN_PLUGIN] =
{
	/*PBF_TYPE_MONO | PBF_TYPE_GRAYSCALE | PBF_TYPE_INDEXCOLOR | */PBF_TYPE_FULLCOLOR /*| PBF_REFERENCE_IMAGE*/,
	/*PBF_TYPE_MONO | PBF_TYPE_GRAYSCALE | PBF_TYPE_INDEXCOLOR | */PBF_TYPE_FULLCOLOR /*| PBF_REFERENCE_IMAGE*/,
	/*PBF_TYPE_MONO | PBF_TYPE_GRAYSCALE | PBF_TYPE_INDEXCOLOR | */PBF_TYPE_FULLCOLOR /*| PBF_REFERENCE_IMAGE*/
};


// TODO: Cӂ̃Rs[Cgݒ肵ĂB
const char* g_szCopyright = "Copyright (C) 2000-2004 by Yasuyuki Kashiwagi. All Rights Reserved.";


HINSTANCE g_hInstance;


///////////////////////////////////////////////////////////////////////////////
// Gg[|Cg

BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) 
	{
		g_hInstance = hInstDLL;
	}
	
	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// vOC擾

DLLExport WORD WINAPI PB_GetPluginInfo(LPSTR szBuf, int nLen)
{
	// TODO: szBuf ɃRs[Cgݒ肵Aȉ̒lԂĂB
	strncpy(szBuf, g_szCopyright, nLen);
	return MAKEWORD(PBPLUGIN_FILTER, PBPLUGIN_FILTER_VERSION);
}


///////////////////////////////////////////////////////////////////////////////
// tB^擾

DLLExport int WINAPI PBF_FilterCount(void)
{
	// TODO: vOCɊ܂܂tB^̐ԂĂB
	return FILTER_IN_PLUGIN;
}


///////////////////////////////////////////////////////////////////////////////
// tB^̎ނƖO̎擾

DLLExport void WINAPI PBF_GetName(int nIndex, LPSTR pszKind, int nKindLen, LPSTR pszName, int nNameLen)
{
	// TODO: kind ɃtB^̎ށAname ɃtB^ݒ肵ĂB
	strncpy(pszKind, g_szKinds[nIndex], nKindLen);
	strncpy(pszName, g_szNames[nIndex], nNameLen);
}


///////////////////////////////////////////////////////////////////////////////
// ΉĂC[W̎ނ擾

DLLExport DWORD WINAPI PBF_GetSupportedFormat(int nIndex)
{
	// TODO: ΉĂtH[}bgݒ肵ĂB
	return g_dwFormats[nIndex];
}


///////////////////////////////////////////////////////////////////////////////
// tB^s

DLLExport int WINAPI PBF_Execute(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	// TODO: tB^̓eLqĂB
	//       (ڂ͂̑̃tB^QlĂ)
	int x1 = pFilterImage->rcSelection.left;
	int y1 = pFilterImage->rcSelection.top;
	int x2 = pFilterImage->rcSelection.right;
	int y2 = pFilterImage->rcSelection.bottom;
	int x, y;

	pFunc->ProgressStart(0, y2 - y1);

	for (y=y1; y<y2; y++) 
	{
		for (x=x1; x<x2; x++) 
		{
			Pixel32 sp;
			Pixel32* dp;

			sp.color = pFilterImage->pSrc[x + y*pFilterImage->nWidth];
			dp = (Pixel32*)&pFilterImage->pDst[x + y*pFilterImage->nWidth];

			switch (nIndex) 
			{
			case 0: /* Red */
				dp->item.r = sp.item.r;
				dp->item.g = 0;
				dp->item.b = 0;
				dp->item.a = sp.item.a;
				break;

			case 1: /* Green */
				dp->item.r = 0;
				dp->item.g = sp.item.g;
				dp->item.b = 0;
				dp->item.a = sp.item.a;
				break;

			case 2: /* Blue */
				dp->item.r = 0;
				dp->item.g = 0;
				dp->item.b = sp.item.b;
				dp->item.a = sp.item.a;
				break;
			}


		}

		pFunc->ProgressSetPos(y - y1);
	}

	pFunc->ProgressEnd();

	return PB_ERR_SUCCESS;
}


///////////////////////////////////////////////////////////////////////////////
// tB^ݒ

DLLExport BOOL WINAPI PBF_Setup(int nIndex, HWND hWnd, PFilterImage* pFilterImage, PProvidedFunc* pFunc)
{
	// TODO: vOC̐ݒs܂B
	//
	//       (1) ݒǂݍ
	//       (2) if (ݒ肪ύX) {
	//       (3)     ݒۑ
	//       (4)     return TRUE;
	//       (5) }
	//       (6) return FALSE;
	//
	//       ݒsȂꍇ TRUE ԂĂB

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
// Visual C++ p GNX|[g̕ϊ

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:PB_GetPluginInfo=_PB_GetPluginInfo@8")
#pragma comment(linker, "/EXPORT:PBF_FilterCount=_PBF_FilterCount@0")
#pragma comment(linker, "/EXPORT:PBF_GetName=_PBF_GetName@20")
#pragma comment(linker, "/EXPORT:PBF_GetSupportedFormat=_PBF_GetSupportedFormat@4")
#pragma comment(linker, "/EXPORT:PBF_Setup=_PBF_Setup@16")
#pragma comment(linker, "/EXPORT:PBF_Execute=_PBF_Execute@16")
#endif

