//-----------------------------------------------------------------------------
// Special Filters
// Copyright (C) 2000-2003 by Yasuyuki Kashiwagi. All Rights Reserved.
//-----------------------------------------------------------------------------

#include "Special.h"


EmbossFilter::EmbossFilter()
{
	int kernel[25] = 
	{
		0, 0, 0, 0, 0,
		0, 1, 0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0,-1, 0,
		0, 0, 0, 0, 0
	};

	SetKind("Special|");
	SetName("Emboss|G{X");
	SetKernel(kernel);
	SetScale(1);
	SetOffset(128);
}

BlowFilter::BlowFilter()
{
	int kernel[25] = {
		1, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 1, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 1
	};

	SetKind("Special|");
	SetName("Blow|Ԃ");
	SetKernel(kernel);
	SetScale(3);
	SetOffset(0);
}
